#!/usr/bin/perl -w

# LSB Test Execution Framework
# Results Page Module (tests_results.pl)
#
# Copyright (C) 2007 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';
use Fcntl ':seek';

autoflush_on();

if ($_POST{"remove"}) {
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			my $path = $CONFIG{"RESULTS_DIR"}."/$_";
			if (-d $path) {
				if ($_POST{$_} and ($_POST{$_} eq "on")) {
					system("rm -rf $path");
				}
				else {
					push @list, $_;
				}	
			}
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
	}
	else {
		print STDERR "Cannot open HISTORY file!\n";
	}
	print "HTTP/1.0 302 Moved\nLocation: tests_results.pl\n\n";
	exit;
}

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if ($_GET{"details"}) {
	if ($_GET{"analysis"}) {
		my $app_name = "";
		my $res_dir = $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"};
		if (open(FILE, "$res_dir/INFO")) {
			while (<FILE>) {
				if (m/Application: (.*)$/) {
					$app_name = $1;
					last;
				}
			}
			close(FILE);
		}
		my $host_platform = `cat $res_dir/test_logs/host_platform`;
		my $lsb_version = `cat $res_dir/test_logs/lsb_version`;
		$host_platform =~ s/[\r\n]//g;
		$lsb_version =~ s/[\r\n]//g;
		my $name_l = "required_libs";
		my $name_i = "required_ints";
		print_header("Test Results", "analysis");
		if ((!-f "$res_dir/$name_l") or (!-f "$res_dir/$name_i")) {
			print <<DATA;
<div id="progress_info">
<font color="green"><b>Please, wait while the list is being generated...</b></font><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span></p>
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById("timer");
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = "";
		tmp += (m < 10) ? "0" + m : m;
		tmp += ":";
		tmp += (s < 10) ? "0" + s : s;
		elem.innerHTML = tmp;
		setTimeout("update_timer()", 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA
			system($CONFIG{"UTILS_DIR"}."/merge.pl -d $res_dir $lsb_version $host_platform $res_dir/${app_name}_${host_platform}_upload_data >/dev/null");
			print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished=1;
var elem_progress_info = document.getElementById("progress_info");
if (elem_progress_info)
	elem_progress_info.style.display = 'none';
// ]]>
</script>
DATA
		}
		my $request_to_send = "";
		if (! -f "$res_dir/test_logs/ftp_upload") {
			$request_to_send = "<p>Please, <a href=\"upload_data.pl?details=$_GET{details}\"><b>send this information</b></a> to the Linux Foundation for publishing in the Linux Applications section of the <a href=\"http://www.linux-foundation.org/navigator/browse/app.php\" target=\"_blank\">LSB Navigator</a>.</p><br />";
		}
		else {
			$request_to_send = "<br />";
		}
		print <<DATA;
<h1>Analysis Results for $app_name on $host_platform</h1>

This page contains analytical information about the application you have tested. It contains the following data:
<ol>
  <li><a href="#libs">List of the external <b>libraries</b></a> needed by the application (based on DT_NEEDED ELF section).</li>
  <li><a href="#ints">List of the external <b>interfaces</b></a> actually required by the application to run.</li>
</ol>
$request_to_send

<script language="javascript" type="text/javascript">
// <![CDATA[

function apply_filter(table_name, value) {
	var lsb_show = true, nlsb_show = true;
	var num_rows_shown = 0;
	if (value == "lsb")
		nlsb_show = false;
	else if (value == "nlsb")
		lsb_show = false;
	var elems = document.getElementsByTagName("TR");
	for (var i=0; i<elems.length; ++i) {
		if (elems[i].className == "lsb_" + table_name) {
			elems[i].style.display = (lsb_show ? '' : 'none');
			if (lsb_show)
				++num_rows_shown;
		}
		else if (elems[i].className == "nlsb_" + table_name) {
			elems[i].style.display = (nlsb_show ? '' : 'none');
			if (nlsb_show)
				++num_rows_shown;
		}
	}
	var elem_empty = document.getElementById(table_name + "_empty_row");
	var elem_num_shown = document.getElementById(table_name + "_num_shown");
	if (elem_empty && elem_num_shown) {
		elem_empty.style.display = ((num_rows_shown == 0) ? '' : 'none');
		elem_num_shown.innerHTML = num_rows_shown;
	}
	var elem_empty_text = document.getElementById(table_name + "_empty_row_text");
	if (elem_empty_text) {
		if (value == "lsb")
			elem_empty_text.innerHTML = "No LSB entries";
		else if (value == "nlsb")
			elem_empty_text.innerHTML = "No non-LSB entries";
		else
			elem_empty_text.innerHTML = "No entries";
	}
}

// ]]>
</script>

DATA
		my $buffer = "";
		my $items_num = 0;
		my $nlsb_items_num = 0;
		if (open(FILE_L, "$res_dir/$name_l")) {
			$buffer .= <<DATA;
<p>Filter by presence in LSB:
<select name="lsb_filter_libs" id="lsb_filter_libs" onchange="javascript:apply_filter('libs', this.value);">
  <option value="lsb">Show LSB only</option>
  <option value="nlsb" selected="selected">Show non-LSB only</option>
  <option value="all">Show all</option>
</select></p>
<table class="wikitable">
  <tr>
    <th width="100">Library</th>
    <th width="50">In&nbsp;LSB?<br />
    </th>
    <th width="400">Application&nbsp;Modules</th>
    <th width="300">Comments</th>
  </tr>
DATA
			while (<FILE_L>) {
				s/[\r\n]//g;
				my @line = split(/;/, $_, 4);
				my $comment = (($line[3] eq "") ? "<td><font color=\"#a0a0a0\">No information</font></td>" : "<td>$line[3]</td>");
				if ($line[1]) {
					$items_num++;
					$buffer .= "  <tr class=\"lsb_libs\" style=\"display: none;\"><td><a href=\"http://www.linux-foundation.org/navigator/browse/rawlib.php?cmd=list-byrunname&amp;RLrunname=$line[0]\" target=\"_blank\">$line[0]</a></td><td align=\"center\"><font color=\"green\"><b>Yes</b></font></td><td>".join("<br />", split(/,/, $line[2]))."</td>$comment</tr>\n";
				}
				else {
					$items_num++;
					$nlsb_items_num++;
					$buffer .= "  <tr class=\"nlsb_libs\"><td><a href=\"http://www.linux-foundation.org/navigator/browse/rawlib.php?cmd=list-byrunname&amp;RLrunname=$line[0]\" target=\"_blank\">$line[0]</a></td><td align=\"center\"><font color=\"red\"><b>No</b></font></td><td>".join("<br />", split(/,/, $line[2]))."</td>$comment</tr>\n";
				}
			}
			$buffer .= "<tr id=\"libs_empty_row\"".(($nlsb_items_num == 0) ? "" : " style=\"display: none;\"")."><td colspan=\"4\" align=\"center\"><span id=\"libs_empty_row_text\" style=\"color: #a0a0a0\">No non-LSB entries</span></td></tr>\n";
			$buffer .= "</table>\n";
			close(FILE_L);
		}
		else {
			$buffer .= "<b><font color=\"red\">Sorry, the file '".$_GET{"details"}."/$name_l' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
		print <<DATA;
<a name="libs"></a><h2>List of Required Libraries ($items_num entries total; <span id="libs_num_shown">$nlsb_items_num</span> entries shown)</h2>
$buffer
<br />

DATA
		$buffer = "";
		$items_num = 0;
		$nlsb_items_num = 0;
		if (open(FILE_I, "$res_dir/$name_i")) {
			$buffer .= <<DATA;
<p>Filter by presence in LSB:
<select name="lsb_filter_ints" id="lsb_filter_ints" onchange="javascript:apply_filter('ints', this.value);">
  <option value="lsb">Show LSB only</option>
  <option value="nlsb" selected="selected">Show non-LSB only</option>
  <option value="all">Show all</option>
</select></p>
<table class="wikitable">
  <tr>
    <th width="400">Interface</th>
    <th width="50">In&nbsp;LSB?<br />
    </th>
    <th width="400">Application&nbsp;Modules</th>
    <th width="300">Comments</th>
  </tr>
DATA
			while (<FILE_I>) {
				s/[\r\n]//g;
				my @line = split(/;/, $_, 7);
				my $disp_name = $line[1];
				my $tooltip = "";
				my $cont_text = "";
				if ($disp_name eq "") {
					$disp_name = $line[0];
					if (length($disp_name) > 50) {
						$tooltip = " title=\"$disp_name\"";
						$cont_text = "<font color=\"red\">&raquo;</font>";
						$disp_name = substr($disp_name, 0, 50)."...";
					}
				}
				$disp_name =~ s/&/&amp;/g;
				$disp_name =~ s/</&lt;/g;
				$disp_name =~ s/>/&gt;/g;
				my $comment = (($line[6] eq "") ? "<td><font color=\"#a0a0a0\">No information</font></td>" : "<td>$line[6]</td>");
				if ($line[3]) {
					$items_num++;
					$buffer .= "  <tr class=\"lsb_ints\" style=\"display: none;\"><td style=\"white-space: normal;\"><a href=\"http://www.linux-foundation.org/navigator/browse/int_single.php?cmd=list-by-name&amp;Iname=$line[0]\" target=\"_blank\"$tooltip>$disp_name</a> $cont_text</td><td align=\"center\"><font color=\"green\"><b>Yes</b></font></td><td>".join("<br />", split(/,/, $line[4]))."</td>$comment</tr>\n";
				}
				else {
					$items_num++;
					$nlsb_items_num++;
					$buffer .= "  <tr class=\"nlsb_ints\"><td style=\"white-space: normal;\"><a href=\"http://www.linux-foundation.org/navigator/browse/int_single.php?cmd=list-by-name&amp;Iname=$line[0]\" target=\"_blank\"$tooltip>$disp_name</a> $cont_text</td><td align=\"center\"><font color=\"red\"><b>No</b></font></td><td>".join("<br />", split(/,/, $line[4]))."</td>$comment</tr>\n";
				}
			}
			$buffer .= "<tr id=\"ints_empty_row\"".(($nlsb_items_num == 0) ? "" : " style=\"display: none;\"")."><td colspan=\"4\" align=\"center\"><span id=\"ints_empty_row_text\" style=\"color: #a0a0a0\">No non-LSB entries</span></td></tr>\n";
			$buffer .= "</table>\n\n";
			close(FILE_I);
		}
		else {
			$buffer .= "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."/$name_i' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
		print <<DATA;
<a name="ints"></a><h2>List of Required Interfaces ($items_num entries total; <span id="ints_num_shown">$nlsb_items_num</span> entries shown)</h2>
$buffer
DATA
	}
	else {
		my $name = "test_log.html";
		print_header("Test Results", "report");
		if (open(FILE, $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/$name")) {
			my $transfer = 0;
			while (<FILE>) {
				if (m/<body>/) {
					s/^.*<body>\n?//i;
					$transfer = 1;
				}
				if ($transfer) {
					s/(<\/body>|<\/html>)\n?//i;
					print $_;
				}
			}
			close(FILE);
		}
		else {
			print "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
	}
}
else {
	print_header("Test Results", "results");

	print "<h1>Test Results</h1>\n";

	print "<form method=\"post\" action=\"tests_results.pl\" name=\"results_list\">\n<table class=\"main\">\n";
	print "  <tr>\n    <td><input type='checkbox' name='check_all' id='check_all' onclick='javascript:check_unckeck_all();' /></td>\n";
	print "    <th width=\"170px\">Date/Time</th>\n";
	print "    <th width=\"170px\">Summary</th>\n";
	print "    <th width=\"300px\">Comment</th>\n  </tr>\n";
	my @list = ();
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			push @list, $_ if (-d $CONFIG{"RESULTS_DIR"}."/$_");
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
		@list = reverse(@list);
		foreach my $name (@list) {
			$_ = $CONFIG{"RESULTS_DIR"}."/$name";
			my @summary = ();
			my @comment = ();
			my $current_field = \@summary;
			if (open(FILE, "$_/INFO")) {
				while (<FILE>) {
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					s/[\r\n]//g;
					if (($_ eq "") and ($current_field != \@comment)) {
						$current_field = \@comment;
						next;
					}
					push @$current_field, $_;
				}
				close(FILE);
			}
			my $fail = -1;
			my $app_name = "";
			my @extraction = ();
			foreach (@summary) {
				if (m/^Verdict: (\S+)/i) {
					if ($1 eq "Success") {
						$fail = 0;
					}
					elsif ($1 eq "Failed") {
						$fail = 1;
					}
				}
				elsif (m/^Application: (.*)$/i) {
					$app_name = $1;
				}
				else {
					# Align numbers by right side (6 digits max)
					s/^(\d+) /("&nbsp;"x(6-length($1))).$1." "/e;
					push @extraction, $_;
				}
			}
			my $jsummary = join("<br />", @extraction);
			$jsummary = "&nbsp;" if ($jsummary eq "");
			my $jcomment = join("<br />", @comment);
			if ($jcomment ne "") {
				$jcomment =~ s/&gt;/>/g;
				$jcomment =~ s/&lt;/</g;
				$jcomment =~ s/&amp;/&/g;
			}
			else {
				$jcomment = "&nbsp;";
			}
			my $image = "";
			my $img_alt = "";
			if ($fail == -1) {
				$fail = ($jsummary =~ m/(\d+) Tests Failed/) ? $1 : -1;
			}
			if ($fail) {
				$image = "TestsFailed.png";
				$img_alt = "TestsFailed";
			}
			else {
				$image = "TestsPassed.png";
				$img_alt = "TestsPassed";
			}
			my $show_name = $name;
			$show_name =~ s/^[^\-]*\-[^\-]*\-$app_name\-([^\-]*)\-([^\-]*)\-([^\-]*)\-([^\-]*)h\-([^\-]*)m\-([^\-]*)s/$3.$2.$1&nbsp;$4:$5:$6/;
			print <<DATA;
  <tr>
    <td><input type='checkbox' name='$name' onclick='javascript:update_state();' /></td>
    <td>
      <table border="0" cellpadding="0" cellspacing="0"><tr>
        <td style="border: none; padding: 0px;">
          <img src="images/$image" alt="$img_alt" width="33" height="30" />
        </td>
        <td style="border: none; padding: 0px;">
          &nbsp;<a href="tests_results.pl?details=$name">$show_name</a><br />&nbsp;Application: $app_name
        </td>
      </tr></table>
    </td>
    <td valign="top"><code>$jsummary</code></td>
    <td valign="top">$jcomment</td>
  </tr>
DATA
		}
	}
	print <<DATA;
</table>
<br /><input type="submit" name="remove" id="remove_button" value="Remove Selected Entries" disabled="disabled" onclick='javascript:return confirm_remove();' />
</form>

<script language="javascript" type="text/javascript">
// <![CDATA[
function count_checked() {
	var num = 0;
	var form = document.results_list;
	for (var i=0; i<form.length; ++i) {
		if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all") && form[i].checked) {
			++num;
		}
	}
	return num;
}

function update_state() {
	var elem = document.getElementById("remove_button");
	if (elem) {
		var num = count_checked();
		elem.disabled = (num == 0);
	}
}

function check_unckeck(box, check) {
	temp = box.onchange;
	box.onchange = null;
	box.checked = check;
	box.onchange = temp;
}

function check_unckeck_all() {
	var elem = document.getElementById("check_all");
	if (elem) {
		var checked = elem.checked;
		var form = document.results_list;
		for (var i=0; i<form.length; ++i) {
			if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all"))
				check_unckeck(form[i], checked);
		}
		update_state();
	}
}

function confirm_remove() {
	var num = count_checked();
	if (num == 0) {
		alert("Nothing selected!");
		return false
	}
	else
		return confirm("Do you wish to delete " + num + " selected report(s)?");
}
// ]]>
</script>
DATA
}

print_footer();
